import tcp.TcpServer;
import tcp.TcpSocket;
import util.Reader;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.BindException;
import java.util.ResourceBundle;

public class Menu {
    private static ResourceBundle resource = ResourceBundle.getBundle("constant");
    private static final String LOCAL_ENCODING = System.getProperty("file.encoding");
    private static final int SERVER_PORT = Integer.parseInt(resource.getString("SERVER_PORT"));

    public static void main(String[] args) {
        help();
        try {
            Reader reader = new Reader();
            String line = null;
            while (!"exit".equals(line = reader.readKB())) {
                if (line == null || "".equals(line)) {
                    System.out.println("输入为空");
                    continue;
                }
                String[] param = line.split(":");
                String cmd = param[0];
                String address = "127.0.0.1";
                switch (cmd) {
                    case "1":
                        System.out.println("启动TCP服务器");
                        // TCP服务器
                        int port = SERVER_PORT;
                        try {
                            if (param.length == 1) {
                                new TcpServer(port);
                            } else if (param.length == 2) {
                                port = Integer.parseInt(param[1]);
                                new TcpServer(port);
                            } else {
                                System.out.println("参数无法解析:" + line);
                            }
                        } catch (NumberFormatException e) {
                            System.out.println("非法参数");
                        } catch (BindException e) {
                            System.out.println(port+"端口被占用");
                        }
                        break;
                    case "2":
                        System.out.println("启动TCP客户端");
                        // TCP客户端
                        try {
                            TcpSocket client = null;
                            if (param.length == 1) {
                                client = new TcpSocket(address, SERVER_PORT);
                            } else if (param.length == 2) {
                                client = new TcpSocket(address, Integer.parseInt(param[1]));
                            } else if (param.length == 3) {
                                client = new TcpSocket(param[1], Integer.parseInt(param[2]));
                            } else {
                                System.out.println("参数无法解析:" + line);
                            }
                            if(client!=null){
                                new Thread(client).start();
                                client.write();
                            }
                        } catch (NumberFormatException e) {
                            System.out.println("非法参数");
                        } catch (Exception e) {
                            System.out.println(e.getMessage());
                        }
                        break;
                    case "3":
                        System.out.println("启动UDP服务器");
                        // UDP服务器
                        System.out.println("功能待开发");
                        break;
                    case "4":
                        System.out.println("发送UDP数据包");
                        // UDP发包工具
                        System.out.println("功能待开发");
                        break;
                    default:
                        System.out.println("无法解析命令");
                }
                help();
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        System.out.println("主程序退出运行");
        System.exit(0);
    }

    public static void help() {
        System.out.println("*******主菜单*******");
        System.out.println("1:运行TCP服务器");
        System.out.println("2:运行TCP客户端");
        System.out.println("3:运行UDP服务器");
        System.out.println("4:发送UDP数据包");
        System.out.println("*******************");
    }
}
